#define ccCRLF chr(13) + chr(10)

* Manually generate some XML.

close tables all
use home() + 'samples\northwind\customers'
lcXML = '<customers>' + ccCRLF
scan
	text to lcXML additive noshow textmerge
	<customer>
		<company><<trim(CompanyName)>></company>
		<contact><<trim(ContactName)>></contact>
		<city><<trim(City)>></city>
	</customer>

  endtext
endscan
lcXML = lcXML + '</customers>' + ccCRLF
strtofile(lcXML, 'Customers.xml')

* Show that we have a encoding problem.

loXML = createobject('MSXML2.DOMDocument')
loXML.load('Customers.xml')
messagebox(loXML.parseError.reason + chr(13) + 'Line: ' + ;
	transform(loXML.parseError.line))
modify file customers.xml

* Fix the problem and try again.

lcXML = '<?xml version="1.0" encoding="Windows-1252"?>' + ccCRLF + ;
	lcXML
lcXML = strtran(lcXML, '&', '&amp;')
strtofile(lcXML, 'Customers.xml')
loXML.load('Customers.xml')
messagebox(loXML.parseError.errorCode)
