*==============================================================================
* File:					SFREPORTS.H
* Purpose:				Constants for Stonefield Reports
* Author:				Doug Hennig
* Copyright:			(c) 1997-2008 Stonefield Systems Group Inc.
* Last revision:		05/08/2008
*==============================================================================

* Include other INCLUDE files.

#include SFRepObj.H
#include SFTreeView.H
**** THIS IS INCLUDED IN SFCTRLS.H WHICH IS INCLUDED IN SFREPOBJ.H
#include FoxPro.H
#include '\Program Files\Microsoft Visual FoxPro 9\FFC\FoxPro_Reporting.H'
#include '\Program Files\Microsoft Visual FoxPro 9\FFC\GDIPlus.h'
#include '\Program Files\Microsoft Visual FoxPro 9\FFC\_FRXCursor.h'

* Record types in REPORTS.DBF.

#define ccFOLDER_TYPE							'F'
#define ccREPORT_TYPE							'R'
#define ccTEMPLATE_TYPE							'T'
#define ccDATAGROUP_TYPE						'G'

* Access levels.

#ifndef cnACCESS_NONE
#define cnACCESS_NONE			0
#define cnACCESS_READ			1
#define cnACCESS_WRITE			2
#endif

* Output options.

#define ccSTR_OUTPUT_FILE						'FILE'
#define ccSTR_OUTPUT_PRINTER					'PRINTER'
#define ccSTR_OUTPUT_PREVIEW					'PREVIEW'
#define ccSTR_OUTPUT_EMAIL						'EMAIL'
#define ccSTR_OUTPUT_NONE						'NONE'

* FRX directives.

#define ccDIRECTIVE_FIELD_EXPR					'*:SFREPORTS EXPRESSION'
#define ccDIRECTIVE_NOEXPR						'*:SFREPORTS NOEXPRESSION'

* Reports table directives.

#define ccDIRECTIVE_CRQUERY						'*:SFREPORTS CRYSTALQUERY'
	* goes in REPORTPROP for Crystal Report followed by the SQL SELECT statement to use
#define ccDIRECTIVE_NOCURSOR					'*:SFREPORTS NOCURSOR'
	* goes in DOQUERY for an external report to flag that we won't create a
	* cursor because the report will do it itself
#define ccDIRECTIVE_SUBTOTAL_ABOVE				'SUBTOTALSABOVE'
	* goes in REPORTPROP for cross-tab report to indicate that subtotals go above details

* Member data attribute names and values.

#define ccMEMBER_DATA_NAME						'sfquery'
#define ccMEMBER_DATA_TYPE						'settings'
#define ccMEMBER_DATA_PROCESS					'process'
#define ccMEMBER_DATA_LINKEXPR					'linkexpr'
#define ccMEMBER_DATA_EXPR						'expression'
#define ccMEMBER_DATA_FORMAT					'format'
#define ccMEMBER_DATA_STRETCH					'stretch'
#define ccMEMBER_DATA_ALIGN						'align'
#define ccMEMBER_DATA_ADJUST_WIDTH				'adjustwidth'
#define ccMEMBER_DATA_VALUE_DEFAULT				'default'
#define ccMEMBER_DATA_VALUE_RIGHT				'right'
#define ccMEMBER_DATA_VALUE_TRUE				'true'
#define ccMEMBER_DATA_VALUE_FALSE				'false'
#define ccMEMBER_DATA_TEMPLATE					'template'
#define ccMEMBER_DATA_TEMPLATE_COLHEADING		'heading'
#define ccMEMBER_DATA_TEMPLATE_FIELD			'field'
#define ccMEMBER_DATA_TEMPLATE_GROUPCOLHEADING	'groupheading'
#define ccMEMBER_DATA_TEMPLATE_GROUPFIELD		'groupfield'
#define ccMEMBER_DATA_TEMPLATE_SUMMARYFIELD		'summaryfield'
#define ccMEMBER_DATA_TEMPLATE_GROUPFOOTER		'groupfooter'
#define ccMEMBER_DATA_TEMPLATE_GROUPSUMMARY		'groupsummary'
#define ccMEMBER_DATA_LINK_TYPE					'link'
#define ccMEMBER_DATA_LINKTYPE					'linktype'
#define ccMEMBER_DATA_LINKTYPE_WEB				'web'
#define ccMEMBER_DATA_LINKTYPE_EMAIL			'email'
#define ccMEMBER_DATA_LINKTYPE_REPORT			'report'
#define ccMEMBER_DATA_LINKTYPE_ACTION			'action'
#define ccMEMBER_DATA_LINKREPORT			    'linkreport'
#define ccMEMBER_DATA_LINKPARAMETER_TYPE	    'linkparameter'
#define ccMEMBER_DATA_VALUETYPE			    	'valuetype'
#define ccMEMBER_DATA_VALUE			    		'value'
#define ccMEMBER_DATA_CONDITION			    	'condition'
#define ccMEMBER_DATA_FIELD			    		'field'
#define ccMEMBER_DATA_ACTION			    	'action'
#define ccMEMBER_DATA_IGNORE					'ignore'
#define ccMEMBER_DATA_OPERATOR					'operator'
#define ccMEMBER_DATA_GROUP						'group'

* Member data directives.

#define ccDIRECTIVE_LISTENER					'listener'
#define ccDIRECTIVE_ROTATION					'rotation'
#define ccDIRECTIVE_FORECOLOR					'forecolor'
#define ccDIRECTIVE_BACKCOLOR					'backcolor'
#define ccDIRECTIVE_ALPHA						'alpha'
#define ccDIRECTIVE_STYLE						'style'
#define ccDIRECTIVE_PROGRESS					'progress'

* REPORTPROP XML elements and attributes.

#define ccREPORTPROP_XML_ROOT_ELEMENT_OPEN		'<reportprop>'
#define ccREPORTPROP_XML_ROOT_ELEMENT_CLOSE		'</reportprop>'
#define ccREPORTPROP_XML_ROOT_ELEMENT			'reportprop'
#define ccREPORTPROP_XML_DATASOURCES_ELEMENT	'datasources'
#define ccREPORTPROP_XML_DATASOURCE_ELEMENT		'datasource'
#define ccREPORTPROP_XML_CHART_ELEMENT			'chart'
#define ccREPORTPROP_XML_LABEL_ELEMENT			'label'
#define ccREPORTPROP_XML_CROSSTAB_ELEMENT		'crosstab'
#define ccREPORTPROP_XML_CHARTSETTINGS			'chartsettings'
#define ccREPORTPROP_XML_COLORS					'colors'
#define ccREPORTPROP_XML_STYLE					'style'
#define ccREPORTPROP_XML_COLUMNS				'columns'
#define ccREPORTPROP_XML_SPACING				'spacing'
#define ccREPORTPROP_XML_LEFT_MARGIN			'leftmargin'
#define ccREPORTPROP_XML_WIDTH					'width'
#define ccREPORTPROP_XML_HEIGHT					'height'
#define ccREPORTPROP_XML_TOP_MARGIN				'topmargin'
#define ccREPORTPROP_XML_BOTTOM_MARGIN			'bottommargin'
#define ccREPORTPROP_XML_SUBTOTAL_ABOVE			'subtotalabove'

* Report types.

#define ccQUICK_REPORT							'Q'
#define ccXTAB_REPORT							'X'
#define ccEXTERNAL_REPORT						'E'
#define ccLABEL_REPORT							'L'
#define ccCHART_REPORT							'C'
#define ccSTR_NEW_WIZARD_ID						'NEWWIZ'

* Standard output types.

#define ccSTR_OUTPUT_ID							'OUTPUT'
#define ccSTR_OUTPUT_TABLE_TYPE					'99'

* Other constants.

#define cnLABEL_LEFT_MIN						0.2500
	* Minimum left margin for a label
#define ccSTR_HELP_ID							'HELP'
	* ID for help in SFRWIZARD.DBF
#define ccSTR_IMPORT_FILE_EXTENSION				'.sfq'
	* The former extension for export files
#define ccSTR_IMPORT_FILE_EXTENSION_NEW			'.sfx'
	* The new extension for export files
#define ccSTR_TEMPLATE_IMPORT_FILE_EXTENSION	'.sqt'
	* The extension for template export files
#define cnFRU_FIELD_SPACING						1000
	* The spacing between fields in a report in FRUs
#define cnNON_REPORTING_FIELD					99
	* The value in a field's nGroup or nChart property if the field's in a
	* report's field collection but doesn't output

* XTab groupings.

#define cnXTAB_ROW_FIELD						2
#define cnXTAB_COLUMN_FIELD						3
#define cnXTAB_DATA_FIELD						0

* Chart groupings.

#define cnCHART_SERIES_FIELD					2
#define cnCHART_CATEGORY_FIELD					1
#define cnCHART_VALUES_FIELD					0

* Standard lengths for outputting field types to text.

#define cnDISPLAY_MEMO_LEN						30
#define cnOUTPUT_MEMO_LEN						255
#define cnOUTPUT_IBY_LEN						20

* Date aggregation functions.

#define ccDATE_AGG_MONTH						'M'
#define ccDATE_AGG_YEAR							'Y'
#define ccDATE_AGG_QUARTER						'Q'

* Strings to look up in SFRWIZARD.DBF to find correct help ID.

#define ccSTR_HELP_WIZARD_TYPES_NAME			'WIZARD TYPES'
#define ccSTR_HELP_COPY_REPORT_NAME				'COPY REPORT'
#define ccSTR_HELP_FIELD_PROPERTIES_NAME		'FIELD PROPERTIES'
#define ccSTR_HELP_REPORT_MENU_NAME				'REPORT MENU'
#define ccSTR_HELP_QUERY						'STONEFIELD QUERY'
#define ccSTR_HELP_PREVIEWING					'PREVIEWING REPORT'
#define ccSTR_HELP_XTAB_PROPERTIES_NAME			'XTAB FIELD PROPERTIES'
#define ccSTR_HELP_LABEL_PROPERTIES_NAME		'LABEL FIELD PROPERTIES'
#define ccSTR_HELP_CHART_PROPERTIES_NAME		'CHART FIELD PROPERTIES'
#define ccSTR_HELP_EXCLUDE						'EXCLUSION FILTER'
