local loXML as XMLAdapter, ;
	loCustomers as XMLTable, ;
	loOrders as XMLTable

* Open the Customers and Orders tables and relate them so XMLAdapter knows how
* to nest them in a hierarchy.

close tables all
use home() + 'samples\northwind\customers'
use home() + 'samples\northwind\orders' order CustomerID in 0
set relation to CustomerID into Orders

* Create an XMLAdapter and add the Customers and Orders tables to it. Nest
* Orders under Customers.

loXML       = createobject('XMLAdapter')
loCustomers = loXML.AddTableSchema('customers', .T.)
loOrders    = loXML.AddTableSchema('orders',    .T.)
loCustomers.Nest(loOrders)

* Tell XMLAdapter to nest and format the XML.

loXML.RespectNesting  = .T.
loXML.FormattedOutput = .T.

* Output and view the XML.

loXML.ToXML('CustomerOrdersAdapter.xml', '', .T.)
modify file CustomerOrdersAdapter.xml nowait
