local loXML as MSXML2.DOMDocument.3.0, ;
	loNode as MSXML2.IXMLDOMNode, ;
	loRoot as MSXML2.IXMLDOMNode

#define ccCRLF chr(13) + chr(10)
#define ccTAB  chr(9)

close tables all
use home() + 'samples\northwind\customers'
loXML = createobject('MSXML2.DOMDocument.3.0')

* Add a processing instruction to the XML indicating Windows-1252 encoding.

loNode = loXML.createProcessingInstruction('xml', 'version="1.0" ' + ;
	'encoding="Windows-1252"')
loXML.appendChild(loNode)

* Create the root "customers" element and add it to the XML.

loRoot = loXML.createElement('customers')
loXML.appendChild(loRoot)

* Go through each customer and create the "customer" element.

scan
	loCust = loXML.createElement('customer')

* Add a CRLF and two tabs before each company element.

	loText = loXML.createTextNode(ccCRLF + ccTAB + ccTAB)
	loCust.appendChild(loText)

* Create the "company" element and add it to the customer element.

	loNode = loXML.createElement('company')
	loNode.text = trim(COMPANYNAME)
	loCust.appendChild(loNode)

* Add a CRLF and two tabs before each contact element.

	loText = loXML.createTextNode(ccCRLF + ccTAB + ccTAB)
	loCust.appendChild(loText)

* Create the "contact" element and add it to the customer element.

	loNode = loXML.createElement('contact')
	loNode.text = trim(CONTACTNAME)
	loCust.appendChild(loNode)

* Add a CRLF and two tabs before each city element.

	loText = loXML.createTextNode(ccCRLF + ccTAB + ccTAB)
	loCust.appendChild(loText)

* Create the "city" element and add it to the customer element.

	loNode = loXML.createElement('city')
	loNode.text = trim(CITY)
	loCust.appendChild(loNode)

* Add a CRLF and one tab after the city element (that is, before the closing
* customer tag).

	loText = loXML.createTextNode(ccCRLF + ccTAB)
	loCust.appendChild(loText)

* Add a CRLF and one tab before each customer element.

	loText = loXML.createTextNode(ccCRLF + ccTAB)
	loRoot.appendChild(loText)

* Add the customer element to the root customers element.

	loRoot.appendChild(loCust)
endscan

* Add a CRLF after the last customer element (ie. before the closing customers
* tag).

loText = loXML.createTextNode(ccCRLF)
loRoot.appendChild(loText)

* View the XML. Note we have to use the Save method because the XML property
* strips out the encoding information.

loXML.save('CustomersElements.xml')
modify file CustomersElements.xml nowait
