local loXML as MSXML2.DOMDocument.3.0, ;
	loNode as MSXML2.IXMLDOMNode, ;
	loRoot as MSXML2.IXMLDOMNode

#define ccCRLF chr(13) + chr(10)
#define ccTAB  chr(9)

close tables all
use home() + 'samples\northwind\customers'
use home() + 'samples\northwind\orders' in 0
loXML = createobject('MSXML2.DOMDocument.3.0')

* Add a processing instruction to the XML indicating Windows-1252 encoding.

loNode = loXML.createProcessingInstruction('xml', 'version="1.0" ' + ;
	'encoding="Windows-1252"')
loXML.appendChild(loNode)

* Create the root "customers" element and add it to the XML.

loRoot = loXML.createElement('customers')
loXML.appendChild(loRoot)

* Go through each customer and create the "customer" element.

scan
	loCust = loXML.createElement('customer')

* Set the attributes.

	loCust.setAttribute('id', trim(CUSTOMERID))
	loCust.setAttribute('company', trim(COMPANYNAME))
	loCust.setAttribute('contact', trim(CONTACTNAME))
	loCust.setAttribute('city', trim(CITY))

* Get the orders for the selected customer, then go through each order and
* create the "order" element.

	liCustID = CUSTOMERID
	select * from Orders where CustomerID = liCustID into cursor CustOrders
	scan
		loOrder = loXML.createElement('order')

* Set the attributes.

		loOrder.setAttribute('orderid', ORDERID)
		loOrder.setAttribute('orderdate', ORDERDATE)
		loOrder.setAttribute('reqdate', REQUIREDDATE)

* Add a CRLF and two tabs before each order element.

		loText = loXML.createTextNode(ccCRLF + ccTAB + ccTAB)
		loCust.appendChild(loText)

* Add the order element to the customer element.

		loCust.appendChild(loOrder)
	endscan

* Add a CRLF and one tab after the last order element (ie. before the closing
* customer tag).

	loText = loXML.createTextNode(ccCRLF + ccTAB)
	loCust.appendChild(loText)

* Add a CRLF and one tab before each customer element.

	loText = loXML.createTextNode(ccCRLF + ccTAB)
	loRoot.appendChild(loText)

* Add the customer element to the root customers element.

	loRoot.appendChild(loCust)
endscan

* Add a CRLF after the last customer element (ie. before the closing customers
* tag).

loText = loXML.createTextNode(ccCRLF)
loRoot.appendChild(loText)

* View the XML. Note we have to use the Save method because the XML property
* strips out the encoding information.

loXML.save('CustomerOrdersDOM.xml')
modify file CustomerOrdersDOM.xml nowait
